% ddegpib - Universelle DDE-Schnittstelle fr GPIB - H.Haftmann, 12/00
%________________________________________________________________________________________________
%--- Allgemeine Aufrufsyntax: ---
%![pfad\]ddegpib.exe				% Aufruf der .EXE
%
%--- Vorhandene Funktionen und Aufrufsyntax: ---
% kanal=    ddeinit('gpib','gertename') 	% Konversations-Start
% kanal=    ddeinit('gpib','brd pad sad tmo eot eos') % Alternative
%           ddeterm(kanal)			% Konversations-Ende
%           ddepoke(kanal,'data','text')	% Text schreiben, s.a. sprintf
%           ddepoke(kanal,'XX',daten)		% Binrdaten schreiben, XX siehe unten
% ret_text= ddereq(kanal,'data',[1 1])		% Text lesen
% ret_array=ddereq(kanal,'data')		% Text lesen und (von Matlab) umwandlen
% ret_text= ibquery(kanal,'text')		% Kurzform aus 'poke' und 'req'
% ret_array=ddereq(kanal,'XX')			% Binrdaten lesen, XX siehe unten
%           ddeexec(kanal,'ibloc')		% Gert auf Lokalbedienung rckschalten
%           ddeexec(kanal,'ibwait[ maske]')	% Warten auf externes Ereignis
% ret_val=  ddereq(kanal,'ibrsp')		% Response-Byte abholen
%           ddeexec(kanal,'ibclr')		% Gert rcksetzen
%           ddepoke(kanal,'config TMO',value)	% TimeOut [s] setzen
%           ddepoke(kanal,'config EOT',value)	% End-Of-Transmission-Flag setzen
% ret_val=  ddereq(kanal,'config TMO')		% TimeOut [s] abfragen
% ret_val=  ddereq(kanal,'config EOT')		% End-Of-Transmission-Flag abfragen
% ret_text= ddereq(kanal,'version')		% Versionsabfrage von DDEGPIB
%           ddeexec(kanal,'help')		% Windows-Hilfe zu DDEGPIB
%
% iberr=    ddereq(kanal,'iberr')		% IBERR-Variable abfragen (Fehlercode)
% ibsta=    ddereq(kanal,'ibsta')		% IBSTA-Variable... (Status-Bits, siehe GPIB.HLP)
% ibcnt=    ddereq(kanal,'ibcnt')		% IBCNT-Variable... (Bytes des letzten Befehls)
%
%--- XX bei Binrdaten ---
% '8'       8-bit-Bytes, vorzeichenlos (vzl.)
% 'i8'      8-bit-Bytes, vorzeichenbehaftet (vzb.)
% 'i16'     16-bit-Integer, vzb., Intel-Notation (least significant byte zuerst [LSB first])
% 'i16m'    16-bit-Integer, vzb., Motorola-Notation (most significant byte zuerst [MSB first])
% {[u]|i}{8|16|32}{[i]|m}   allgemein, wer's versteht
%
%--- Erforderliches Format von Binrdaten beim LESEN: ---
% <Text>	(beliebiger Header-Text ohne #, kann auch leer sein)
% #		(literales Doppelkreuz)
% m		(1 ASCII-Ziffer: Anzahl der folgenden ASCII-Ziffern)
% n		(m ASCII-Ziffern: Anzahl der folgenden binren 8-bit-Bytes)
% <Rest>	(Binrdaten wie bei XX angegeben)
% Dieses Format trifft auf den Yokogawa-Oszi, den HP546xx und den R&S-Waveform-Generator zu
% und ermglicht sehr hohe Datenbertragungsraten
%
%--- Beispiel (hypothetisches Oszilloskop): ---
% k=        ddeinit('gpib','oszi');		% Kanalhandle fr 'oszi' ergattern
%           ddepoke(k,'data',sprintf('timebase %f',zeitbasis));
% peak_text=ibquery(k,'peak?');
%           ddeterm(k);
%
%--- Siehe auch: ---
% N:\HENNI\GPIB\TPWGPIB\GPIB.HLP - Detaillierte Beschreibung aller GPIB-Funktionen
% (befindet sich im Programm-Manager unter "CD-Infos")
% h#s 12/00
